#include <asm-arm/arch-sa1100/hijack.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>

#define BUTTON_FLAGS_SHIFT	(0x40000000)	// toggle shift state when sending
#define BUTTON_FLAGS_UI		(0x20000000)	// send only if player menus are idle
#define BUTTON_FLAGS_NOTUI	(0x10000000)	// send only if player menus are active
#define BUTTON_FLAGS_ALTNAME	(0x08000000)	// use alternate name when displaying
#define BUTTON_FLAGS_SOUNDADJ	(0x04000000)	// send only if player Vol/Loud/Bal/Fader popup is active
#define BUTTON_FLAGS_UISTATE	(BUTTON_FLAGS_UI|BUTTON_FLAGS_NOTUI|BUTTON_FLAGS_SOUNDADJ)
#define BUTTON_FLAGS		(0xff000000)
#define IR_NULL_BUTTON		(~BUTTON_FLAGS)
#define IR_FAKE_NEXTSRC		(IR_NULL_BUTTON-13)


int main()
{

	int fd;
	int rc;
	int looping=1;
	int exit = 0;
	unsigned long data,
		fake_buttons[2] = {2,IR_FAKE_NEXTSRC},
		buttons[5] = {5, IR_TOP_BUTTON_PRESSED, IR_TOP_BUTTON_RELEASED, IR_BOTTOM_BUTTON_PRESSED, IR_BOTTOM_BUTTON_RELEASED};

	unsigned char screenbuf[EMPEG_SCREEN_BYTES] = {0,};
	hijack_geom_t fullscreen_geom = { 0, 31, 0, 127};

	fd = open("/dev/display", O_RDWR);
	top: while ( !exit )
	{
		char *menulabels[] = {"faketest", NULL};
		rc = ioctl(fd, EMPEG_HIJACK_WAITMENU, menulabels);

		rc = ioctl(fd,EMPEG_HIJACK_BINDBUTTONS, buttons);
		rc = ioctl(fd,EMPEG_HIJACK_SETGEOM, &fullscreen_geom);
		while ( looping )
		{
			rc = ioctl(fd, EMPEG_HIJACK_DISPTEXT, "Top to test, bottom to quit");
			rc = ioctl(fd,EMPEG_HIJACK_WAITBUTTONS, &data);
			if ( data ==  IR_BOTTOM_BUTTON_PRESSED )
			{
				looping=0;
				exit = 1;
			}
			else if ( data ==  IR_TOP_BUTTON_PRESSED )
			{
				rc = ioctl(fd, EMPEG_HIJACK_DISPTEXT, "NextSrc sent");
				rc = ioctl(fd, EMPEG_HIJACK_INJECTBUTTONS, fake_buttons);
				sleep(1);
				rc = ioctl(fd, EMPEG_HIJACK_DISPTEXT, "Test pased, no crash");
			}

		}
	}
	rc = ioctl(fd,EMPEG_HIJACK_WAITMENU, NULL);
}